%define PRELUDE_GROUP prelude
%define POLICYCOREUTILSVER 2.0.78-1
%define SELINUXTARGETEDVER 3.7.19-279

Name:  prelude-lml
Epoch:  1
Version: 3.1.0
Release: 1%{?dist}
Summary: The prelude log analyzer
Group:  System Environment/Daemon
License: GPLv2+
URL:  https://www.prelude-siem.org/
Source0: %{name}-%{version}.tar.gz
Source1: prelude-lml.init
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: gamin-devel, pcre-devel
BuildRequires: libprelude-devel >= 1:3.1.0
BuildRequires: libprelude-devel < 1:3.2.0
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun): /sbin/service
Requires: libprelude >= 1:3.1.0
Requires: libprelude < 1:3.2.0

%description
Prelude-LML is a log analyser that allows Prelude to collect and
analyze information from all kind of applications emitting logs or
syslog messages in order to detect suspicious activities and transform
them into Prelude-IDMEF alerts. Prelude-LML handles events generated
by a large set of applications,


%package devel
Summary: Header files and libraries for libprelude development
Group: Development/Libraries
Requires: libprelude-devel, prelude-lml = %{epoch}:%{version}-%{release}


%description devel
Libraries, include files, etc you can use to develop custom
Prelude LML plugins.


%package selinux
Summary: SELinux policy for prelude-lml
Provides: selinux-policy-base
Group: System Environment/Base
BuildRequires: checkpolicy
BuildRequires: policycoreutils >= %{POLICYCOREUTILSVER}
BuildRequires: bzip2
Requires(pre): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(pre): coreutils
Requires(pre): selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: prelude-lml = %{epoch}:%{version}-%{release}
Requires(post): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(postun): policycoreutils >= %{POLICYCOREUTILSVER}
BuildArch: noarch


%description selinux
SELinux policy for prelude-lml.


%define loadpolicy() \
. %{_sysconfdir}/selinux/config; \
( cd /usr/share/selinux/%1; semodule -n -b base.pp.bz2 -i %{name}.pp.bz2 -s %1 &> /dev/null ); \


%prep
%setup -q


%build
%configure
make %{?_smp_mflags}
cd $RPM_BUILD_DIR/%{name}-%{version}/selinux/
make


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_datadir}/selinux/targeted/
mkdir -p %{buildroot}/%{_initrddir}
mkdir -p %{buildroot}/%{_sharedstatedir}/%{name}/
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/ruleset/
mkdir -p %{buildroot}/%{_var}/run/%{name}/
make install DESTDIR=%{buildroot} INSTALL="%{__install} -c -p"
install -m 755 %{SOURCE1} %{buildroot}/%{_initrddir}/%{name}
install -m 644 $RPM_BUILD_DIR/%{name}-%{version}/selinux/%{name}.pp.bz2 \
    %{buildroot}/%{_datadir}/selinux/targeted/
rm -f %{buildroot}/%{_libdir}/%{name}/debug.la
rm -f %{buildroot}/%{_libdir}/%{name}/pcre.la


%clean
rm -rf %{buildroot}

%pre
getent passwd prelude-lml >/dev/null || \
/usr/sbin/useradd -M -N -r -d / -s /sbin/nologin \
        -c "prelude-lml" prelude-lml > /dev/null 2>&1 || :
/usr/sbin/usermod -g %{PRELUDE_GROUP} prelude-lml > /dev/null 2>&1 || :

%post
/sbin/ldconfig
/sbin/chkconfig --add %{name}

%post selinux
if [ $1 -eq 1 ]; then
   %loadpolicy targeted prelude-lml
   restorecon %{_sysconfdir}/%{name} || :
   restorecon %{_initrddir}/%{name} || :
   restorecon -R %{_sharedstatedir}/%{name} || :
else
   semodule -n -s targeted -r prelude-lml 2>/dev/null
   %loadpolicy targeted prelude-lml
fi


%preun
if [ $1 = 0 ]; then
        /sbin/service %{name} stop > /dev/null 2>&1 || :
        /sbin/chkconfig --del %{name}
fi


%postun
/sbin/ldconfig
if [ "$1" -ge "1" ]; then
        /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi


%postun selinux
semodule -n -s targeted -r prelude-lml 2>/dev/null || :
/sbin/restorecon -R %{_sysconfdir}/%{name} || :
/sbin/restorecon -R %{_libdir}/%{name} || :
/sbin/restorecon -R %{_sharedstatedir}/%{name} || :
/sbin/restorecon %{_initrddir}/%{name} || :


%files
%defattr(-,root,root,-)
%doc COPYING NEWS HACKING.README README
%attr(0770,prelude-lml,prelude) %dir %{_sysconfdir}/%{name}/
%config(noreplace) %attr(0640,prelude-lml,prelude) %{_sysconfdir}/%{name}/*
%attr(0770,prelude-lml,prelude) %dir %{_sysconfdir}/%{name}/ruleset/
%dir %attr(0775,prelude-lml,prelude) %{_var}/run/%{name}
%{_initrddir}/%{name}
%{_bindir}/prelude-lml
%dir %{_libdir}/%{name}/
%{_libdir}/%{name}/debug.so
%{_libdir}/%{name}/pcre.so
%attr(0770,prelude-lml,prelude) %dir %{_sharedstatedir}/%{name}/

%files selinux
%{_datadir}/selinux/targeted/%{name}.pp.bz2


%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/%{name}/
%{_includedir}/%{name}/prelude-lml.h


%changelog
* Wed Sep 14 2016 Thomas Andrejak <thomas.andrejak@c-s.fr> - 3.1.0-1
- New upstream release

* Thu Sep 01 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc3-1
- New upstream release

* Fri Aug 19 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc2-1
- New upstream release

* Wed Aug 10 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc1-2
- Fix libprelude dependencies

* Sun Aug 07 2016 Thomas Andrejak <thomas.andrejak@c-s.fr> - 3.1.0rc1-1
- New upstream release

* Thu Apr 21 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0-1
- New upstream release

* Fri Apr 15 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0rc4-1
- New upstream release

* Fri Apr 08 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc3-1
- New upstream release

* Fri Apr 01 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc2-1
- New upstream release

* Fri Mar 25 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc1-1
- New upstream release

* Fri Mar 18 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta2-1
- New upstream release
- Fix permissions for /etc/prelude-lml/ruleset
- Mask the messages of usermod command
- Remove dependency on prelude-lml-rules

* Fri Feb 26 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta1-1
- New upstream release
- Add libprelude dependency
- Use a dedicated prelude-lml user
- Fix typos

* Tue Jan 12 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0alpha1-1
- New upstream release
- Integrate SELinux policy

* Wed Jul 22 2015 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6-1
- New upstream release

* Thu Oct 16 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6rc3-1
- New upstream release

* Tue Sep 16 2014 Song Tran <song.tran@c-s.fr> - 1.2.6rc1-1
- New upstream release

* Mon Jul 21 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.5-2
- Added a short sleep in init script before restoring SELinux

* Tue Sep 24 2013 Jean-Charles ROGEZ <jean-charles.rogez@c-s.fr> - 1:1.0.2-2
- Added prelude-lml-rules dependency

* Wed Sep 18 2013 Jean-Charles ROGEZ <jean-charles.rogez@c-s.fr> - 1:1.0.2-1
- Removed ruleset, added HACKING and README files

* Wed Jun 15 2011 Vincent Quéméner <vincent.quemener@c-s.fr> - 1.0.0-5
- Rebuilt for RHEL6

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun May 02 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0-3
- Fixed requires

* Fri Apr 30 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0-2
- new upstream release

* Mon Feb 08 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0rc2-1
- new upstream release

* Sat Jan 30 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0rc1-1
- new upstream release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jul 21 2009 Steve Grubb <sgrubb@redhat.com> 0.9.15-1
- new upstream release

* Wed Apr 22 2009 Steve Grubb <sgrubb@redhat.com> 0.9.14-3
- Adjust dir and config file permissions

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.14-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Oct 17 2008 Steve Grubb <sgrubb@redhat.com> 0.9.14-1
- new upstream release fixing bz #463459

* Sat Oct 11 2008 Steve Grubb <sgrubb@redhat.com> 0.9.13-2
- improved mod_security rules

* Wed Aug 27 2008 Steve Grubb <sgrubb@redhat.com> 0.9.13-1
- new upstream release

* Wed Jun 25 2008 Tomas Mraz <tmraz@redhat.com> - 0.9.12.2-2
- rebuild with new gnutls

* Thu Apr 24 2008 Steve Grubb <sgrubb@redhat.com> 0.9.12.2-1
- new upstream release

* Wed Feb 20 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.11-2
- Autorebuild for GCC 4.3

* Mon Jan 14 2008 Steve Grubb <sgrubb@redhat.com> 0.9.11-1
- new upstream version 0.9.11

* Thu Jan 09 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.8.1-5
- changed init-script description

* Mon Jan 08 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.8.1-4
- added new /var/lib directory

* Fri Jan 05 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.8.1-3
- added init-script
- changed some macros in %%files

* Tue Jan 02 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.8.1-2
- fixed debug problems
- fixed encoding problems

* Fri Dec 29 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.8.1-1
- moved to new upstream version 0.9.8.1
- changed dirowner of /etc/prelude-lml

* Mon Nov 20 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.7-2
- Some minor fixes in requirements

* Tue Oct 23 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.7-1
- New Fedora build based on release 0.9.7
